import { _decorator, Component, Node, BufferAsset, Button } from 'cc';
const { ccclass, property } = _decorator;
zip.configure({
    useWebWorkers: false
});

@ccclass('Test')
export class Test extends Component {
    @property({type: BufferAsset})
    zipBinFile = null;

    onLoad()
    {
        if(cc.sys.isNative)
        {
            if(!Blob.prototype.text)
            {
                Blob.prototype.text = function()
                {
                    return this.data;
                }
            }
        }
    }

    onClickDecompress()
    {
        const reader = new zip.ZipReader(new zip.Uint8ArrayReader(new Uint8Array(this.zipBinFile.buffer())));
        reader.getEntries().then((entries)=>{
            if (entries.length) {
                entries[0].getData(
                    //new zip.TextWriter()
                    new zip.BlobWriter(zip.getMimeType(entries[0].filename))
                ).then((data)=>{
                    console.log("Decompress text");
                    console.log(data);
                
                }).catch((e)=>{
                    console.log(e.message);
                });
                reader.close();
            }
        
        }).catch((e)=>{
            console.log(e.message);
        });
    }
}

